{The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: ocNetwork.pas, released on 3 September 2005.

The Initial Developer of the Original Code is Alexey Nikitayev [nikitayev@rsu.ru]
All Rights Reserved.

Contributor(s):

Last Modified: 3 September 2005

You may retrieve the latest version of this file at the Project Opencomputer's home page,
located at http://opencomputer.narod.ru/

Known Issues:
}
unit ocNetwork;

interface
uses Windows,Classes, SysUtils;

function EnumNetwork( dwLevel:DWORD; SL:TStrings; lpNet:PNetResource=nil):BOOL;

implementation

//   Form1->ListBox1
//  EnumHandler  HWND ListBox'
// ----------------------------------------------------------------
function EnumNetwork( dwLevel:DWORD; SL:TStrings; lpNet:PNetResource=nil):BOOL;
var
  ret:BOOL;
  dwStatus, dwSize, dwEntries, i:DWORD;
  //j:DWORD;
  //lpStr:string;
  lpNewNet:PNETRESOURCE;
  lpNewNetTmp:PNETRESOURCE;
  hEnum:THANDLE;
label mend;
begin
   ret:=TRUE;
   lpNewNet:=nil;
   hEnum:=0;

   dwStatus := WNetOpenEnum( RESOURCE_GLOBALNET, //  Look for the works
                            RESOURCETYPE_ANY,   //  when opening
                            0, lpNet, hEnum );
   if ( dwStatus <> NO_ERROR ) then
   begin 
     ret:=FALSE; 
     goto mend; 
   end;
   //  Allocate buffer space for a mess of objects
   dwEntries := 1000; //  We can handle up to 128 entries
   dwSize := sizeof(NETRESOURCE) * dwEntries;
   GetMem(lpNewNet,dwSize);
   if (lpNewNet=nil) then
   begin 
     ret:=FALSE; 
     goto mend; 
   end;
   //  Enumerate into the buffer
   dwStatus := WNetEnumResource( hEnum, dwEntries, lpNewNet, dwSize );

   if ( dwStatus <> NO_ERROR ) then //  Rats...error, free memory and exit
   begin
      ret:=FALSE;
      goto mend;
   end;
   WNetCloseEnum( hEnum );//  Done with the handle...close it
   hEnum:=0;

   lpNewNetTmp:=lpNewNet;
   for  i:=0 to dwEntries-1 do //  Loop through each entry
   begin
      //lpStr:='';
      {if (lpNewNet.dwDisplayType=RESOURCEDISPLAYTYPE_NETWORK) then
      begin
        lpStr:=lpStr+string(lpNewNet.lpProvider);
      end;}

      if( lpNewNet.lpRemoteName<>nil ) then //  Is there a name?
      begin
         {if( lpNewNet.dwDisplayType = RESOURCEDISPLAYTYPE_DOMAIN ) then
            lpStr:=lpStr + 'Domain...';

         if( lpNewNet.dwDisplayType = RESOURCEDISPLAYTYPE_GENERIC ) then
            lpStr:=lpStr + 'Generic..';

         if( lpNewNet.dwDisplayType = RESOURCEDISPLAYTYPE_SERVER ) then
            lpStr:=lpStr + 'Server...';

         if( lpNewNet.dwDisplayType = RESOURCEDISPLAYTYPE_SHARE ) then
            lpStr:=lpStr + 'Share....';

         if (dwLevel>0) then
           for j := 0 to dwLevel-1 do    //  Indent levels deeper with spaces
              lpStr:=lpStr + '......'; }
         //  Add name and send to listbox
         //lpStr:=lpStr + string(lpNewNet.lpRemoteName);
         if( lpNewNet.dwDisplayType = RESOURCEDISPLAYTYPE_SERVER ) then
           SL.Add(lpNewNet.lpRemoteName);
         // IP    
        // if( lpNewNet.dwDisplayType := RESOURCEDISPLAYTYPE_SERVER )
        //   if(!GetIP(&lpNewNet.lpRemoteName[2],lpStr))continue;
      end;
      //      
      if (dwLevel < 2) then //0:=,1:=Domain,2:=Host,3:=Resource
        EnumNetwork( dwLevel + 1, SL, lpNewNet );
      Inc(lpNewNet);
   end;
   lpNewNet:=lpNewNetTmp;
mend:
   if (hEnum<>0) then WNetCloseEnum( hEnum );
   //if (lpStr<>'') then lpStr:='';
   if (lpNewNet<>nil) then FreeMem(lpNewNet);
   result:=ret;
end;
//-------------------------------------------------------------
// Sample:   EnumHandler( Form1->ListBox1->Handle, 0, NULL );
end.
 